// DlgProxy.cpp : implementation file
//

#include "stdafx.h"
#include "ContainerApp.h"
#include "DlgProxy.h"
#include "ContainerAppDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CContainerAppDlgAutoProxy

IMPLEMENT_DYNCREATE(CContainerAppDlgAutoProxy, CCmdTarget)

CContainerAppDlgAutoProxy::CContainerAppDlgAutoProxy()
{
	EnableAutomation();
	
	// To keep the application running as long as an automation 
	//	object is active, the constructor calls AfxOleLockApp.
	AfxOleLockApp();

	// Get access to the dialog through the application's
	//  main window pointer.  Set the proxy's internal pointer
	//  to point to the dialog, and set the dialog's back pointer to
	//  this proxy.
	ASSERT (AfxGetApp()->m_pMainWnd != NULL);
	ASSERT_VALID (AfxGetApp()->m_pMainWnd);
	ASSERT_KINDOF(CContainerAppDlg, AfxGetApp()->m_pMainWnd);
	m_pDialog = (CContainerAppDlg*) AfxGetApp()->m_pMainWnd;
	m_pDialog->m_pAutoProxy = this;
}

CContainerAppDlgAutoProxy::~CContainerAppDlgAutoProxy()
{
	// To terminate the application when all objects created with
	// 	with automation, the destructor calls AfxOleUnlockApp.
	//  Among other things, this will destroy the main dialog
	if (m_pDialog != NULL)
		m_pDialog->m_pAutoProxy = NULL;
	AfxOleUnlockApp();
}

void CContainerAppDlgAutoProxy::OnFinalRelease()
{
	// When the last reference for an automation object is released
	// OnFinalRelease is called.  The base class will automatically
	// deletes the object.  Add additional cleanup required for your
	// object before calling the base class.

	CCmdTarget::OnFinalRelease();
}

BEGIN_MESSAGE_MAP(CContainerAppDlgAutoProxy, CCmdTarget)
	//{{AFX_MSG_MAP(CContainerAppDlgAutoProxy)
		// NOTE - the ClassWizard will add and remove mapping macros here.
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

BEGIN_DISPATCH_MAP(CContainerAppDlgAutoProxy, CCmdTarget)
	//{{AFX_DISPATCH_MAP(CContainerAppDlgAutoProxy)
		// NOTE - the ClassWizard will add and remove mapping macros here.
	//}}AFX_DISPATCH_MAP
END_DISPATCH_MAP()

// Note: we add support for IID_IContainerApp to support typesafe binding
//  from VBA.  This IID must match the GUID that is attached to the 
//  dispinterface in the .ODL file.

// {8F149D04-720B-11D2-8BB0-000000000000}
static const IID IID_IContainerApp =
{ 0x8f149d04, 0x720b, 0x11d2, { 0x8b, 0xb0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0 } };

BEGIN_INTERFACE_MAP(CContainerAppDlgAutoProxy, CCmdTarget)
	INTERFACE_PART(CContainerAppDlgAutoProxy, IID_IContainerApp, Dispatch)
END_INTERFACE_MAP()

// The IMPLEMENT_OLECREATE2 macro is defined in StdAfx.h of this project
// {8F149D02-720B-11D2-8BB0-000000000000}
IMPLEMENT_OLECREATE2(CContainerAppDlgAutoProxy, "ContainerApp.Application", 0x8f149d02, 0x720b, 0x11d2, 0x8b, 0xb0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0)

/////////////////////////////////////////////////////////////////////////////
// CContainerAppDlgAutoProxy message handlers
